#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include "casl2.h"

CORD *opsearch(char *opcode); /* opcord[]e[u當Ŏw肳ꂽR}hT */
int r(char *gr); /* WX^̕񂩂烌WX^ԍԂ */
int countComma(char *str); /* ̒','̐𐔂 */

CORD opcord[36]={
            {"ADDA", ADDA, 2,MACHINE  },
            {"ADDL", ADDL, 2,MACHINE  },
            {"AND",  AND,  2,MACHINE  },
            {"CALL", CALL, 2,MACHINE  },
            {"CPA",  CPA,  2,MACHINE  },
            {"CPL",  CPL,  2,MACHINE  },
            {"DC",   DC,   0,ASSEMBLER},
            {"DS",   DS,   0,ASSEMBLER},
            {"END",  END,  0,ASSEMBLER},
            {"IN",   IN,   3,MACRO    },
            {"JMI",  JMI,  2,MACHINE  },
            {"JNZ",  JNZ,  2,MACHINE  },
            {"JOV",  JOV,  2,MACHINE  },
            {"JPL",  JPL,  2,MACHINE  },
            {"JUMP", JUMP, 2,MACHINE  },
            {"JZE",  JZE,  2,MACHINE  },
            {"LAD",  LAD,  2,MACHINE  },
            {"LD",   LD,   2,MACHINE  },
            {"NOP",  NOP,  1,MACHINE  },
            {"OR",   OR,   2,MACHINE  },
            {"OUT",  OUT,  3,MACRO    },
            {"POP",  POP,  1,MACHINE  },
            {"PUSH", PUSH, 2,MACHINE  },
            {"RET",  RET,  1,MACHINE  },
            {"RPOP", RPOP, 1,MACRO    },
            {"RPUSH",RPUSH,1,MACRO    },
            {"SLA",  SLA,  2,MACHINE  },
            {"SLL",  SLL,  2,MACHINE  },
            {"SRA",  SRA,  2,MACHINE  },
            {"SRL",  SRL,  2,MACHINE  },
            {"ST",   ST,   2,MACHINE  },
            {"START",START,0,ASSEMBLER},
            {"SUBA", SUBA, 2,MACHINE  },
            {"SUBL", SUBL, 2,MACHINE  },
            {"SVC",  SVC,  2,MACHINE  },
            {"XOR",  XOR,  2,MACHINE  }
};

int analyze(SENTENCE *result, char *line){
	char *s;
	char *p,*pw;
	int  i,comma;
	CORD *code;
	int strFlag;

	s=line;
	result->label[0]=result->opcode[0]=result->oprand[0]=result->address[0]=result->comment[0]='\0';
/* x̐؂o */
	p = result->label;
	if(*s=='\n'){ /* s̐擪śAᔽ */
		fprintf(stderr,"s͏ᔽł:"); /* ĂяoŁAG[s\ */
		return (result->kind=ERROR);
	}
	if(*s!=';'){ /* s̐擪RgłȂ́Ax */
		for(i=0;!isspace(*s);i++){
			if(i>LABELSIZE){
				fprintf(stderr,"x:");
				return (result->kind=ERROR);
			}
			if(!isupper(*s) && !isdigit(*s)){
				fprintf(stderr,"x̍\łȂ:");
				return (result->kind=ERROR);
			}
			*p++=*s++;
		}
		*p='\0';
		if(i != 0){
			if(!isupper(result->label[0])){
				fprintf(stderr,"x̐擪p啶łȂ:");
				return (result->kind=ERROR);
			}
			p=result->label;
			if(p[0]=='G' && p[1]=='R' && p[2] >='0' && p[2] <='7' && p[3]=='\0'){
				fprintf(stderr,"xGR0`GR7͎gpłȂ:");
				return (result->kind=ERROR);
			}
		}
	}
/* 󔒂̃XLbv */
	while(isspace(*s))
		s++;
/* (s)̏ */
	if(*s=='\n' || *s=='\0'){
		fprintf(stderr,"߃R[hȂ:");
		return (result->kind=ERROR);
	}
	if(*s==';'){
		s++;
		strncpy(result->comment,s,LINESIZE);
		if(result->comment[LINESIZE-1]!='\0'){
			result->comment[LINESIZE-1]='\0';
			fprintf(stderr,"Rg:");
			return (result->kind=ERROR);
		} else {
			result->kind=COMMENT;
			return (NOERROR);
		}
	}
/* ߂̐؂o */
	p=result->opcode;
	for(i=0;!isspace(*s);i++){
		if(i>OPCODESIZE){
			fprintf(stderr,"sȖ߃R[h:");
			return (result->kind=ERROR);
		}
		*p++=*s++;
	}
	*p='\0';
/* ߂̕ */
	if(NULL==(code=opsearch(result->opcode))){
			fprintf(stderr,"sȖ߃R[h:");
			return (result->kind=ERROR);
	}
	result->op   = code->val;
	result->size = code->size;
	result->kind = code->kind;
/* 󔒂̃XLbv */
	while(isspace(*s))
		s++;
/* ߂̏ */
	if(*s=='\n' || *s=='\0'){
		if(result->op == RET || result->op == NOP || result->op == RPUSH || result->op == RPOP || result->op == END)
			return (NOERROR); /* @Bꖽ߂ŃIyhȂł悢 */
		else if(result->kind == MACHINE){
			fprintf(stderr,"IyhKv:");
			return (result->kind=ERROR);
		} else
			return (NOERROR);
	}
	if(*s==';'){
		s++;
		strncpy(result->comment,s,LINESIZE);
		if(result->comment[LINESIZE-1]!='\0'){
			result->comment[LINESIZE-1]='\0';
			fprintf(stderr,"Rg:");
			return (ERROR);
		}
		if(result->op == RET || result->op == NOP)
			return (NOERROR);
		else if(result->kind == MACHINE){
			fprintf(stderr,"IyhKv:");
			return (result->kind=ERROR);
		} else
			return (NOERROR);
	}
/* IyhƃRg̐؂o */
	strFlag=0; /* 萔̊O */
	p=result->oprand;
	for(i=0;;i++){
		if(*s=='\''){ /* Iyh𑖍Ă鎞Ɂu'v */
			if(strFlag){ /* 萔̒𑖍Ă鎞 */
				if(*(s+1)=='\''){ /* Q̘Au'v̎́A*/
					if(i>LINESIZE){
						fprintf(stderr,"Iyh:");
						return (result->kind=ERROR);
					}
					*p++=*s++; /* i߂ */
				} else 
					strFlag=0; /* 萔I*/
			} else
				strFlag=1; /* 萔n܂ */
		}
		if(i>LINESIZE){
			fprintf(stderr,"Iyh:");
			return (result->kind=ERROR);
		}
		*p++=*s++;
		if(isspace(*s) && strFlag==0 || *s=='\n' || *s=='\0') /* 󔒂𔭌萔łȂȂA邢́AsIȂ */
			break; /* [v𔲂 */
	}
	*p='\0';
	if(strFlag){
		fprintf(stderr,"萔ĂȂ:");
		return (result->kind=ERROR);
	}
/* @Bꖽ߂̎̃IyhiWX^j */
	result->r1=result->r2=0;
	comma=countComma(result->oprand);/* strtoḱAA','PɂĂ܂̂Ő`FbN邽 */
	if(result->oprand[0]=='\0'){
		fprintf(stderr,"IyhKv:");
		return (result->kind=ERROR);
	}
	if(NULL==(p=strdup(result->oprand))){
		fprintf(stderr,"ƗpsĂ:");
		return (ERROR);
	}
	if(result->kind==MACHINE && result->size==2){ /* @Bꖽ߂ŁAW꒷Q̎ */
		pw=strtok(p,DELIMITER);/* Iyh́AJ}EOSŋ؂ */
		switch(result->op & 0xF000){
		  case 0x6000:/*   */
		  case 0x7000:/* PUSH  */
		  case 0x8000:/* CALL  */
		  case 0xF000:/* SVC   */
			if(pw==NULL){
				fprintf(stderr,"IyhKv:");
				return (result->kind=ERROR);
			}
			if(strlen(pw)>LABELSIZE && *pw!='='){ /* ڂ̃g[ŃAAhXłBełȂxiTCYȉjł */
				fprintf(stderr,"AhX̋Lq:");
				return (result->kind=ERROR);
			}
			strcpy(result->address,pw);
			if(NULL!=(pw=strtok(NULL,DELIMITER))){
				if(comma!=1){ /* J}͂P̂͂ */
					fprintf(stderr,"Iyh̏:");
					return (result->kind=ERROR);
				}
				if(ERROR==(i=r(pw)) || 3!=strlen(pw)){
					fprintf(stderr,"WX^̎w肪:");
					return (result->kind=ERROR);
				}
				if(i==0){
					fprintf(stderr,"wWWX^GR0͎gpłȂ:");
					return (result->kind=ERROR);
				}
				result->r2 = i;
			} else { /* NULL ̎́AWX^w薳 */
				if(comma!=0){ /* AhX̎́AJ}͂Ô͂ */
					fprintf(stderr,"Iyh̏:");
					return (result->kind=ERROR);
				}
			}
			break;
		  default:
			if(ERROR==(i=r(pw))){
				fprintf(stderr,"WX^̎w肪:");
				return (result->kind=ERROR);
			}
			result->r1 = i;
			if(NULL==(pw=strtok(NULL,DELIMITER))){
				fprintf(stderr,"Iyh̏:");
				return (result->kind=ERROR);
			}
			if(strlen(pw)==3 && ERROR!=(i=r(pw))){/* IyĥQ߂RŃWX^Ƃĉ߂łȂ */
				if(comma!=1){ /* J}͂P̂͂ */
					fprintf(stderr,"Iyh̏:");
					return (result->kind=ERROR);
				}
				result->r2 = i;
				result->size = 1;  /* P꒷ */
				result->op += RTOR;
			} else{ /* AhXł͂ */
				if(strlen(pw)>LABELSIZE && *pw!='='){
					fprintf(stderr,"AhX̋Lq:");
					return (result->kind=ERROR);
				}
				strcpy(result->address,pw);
				if(result->address[0]=='\0'){
					fprintf(stderr,"AhXȂ:");
					return (result->kind=ERROR);
				}
			}
			if(NULL!=(pw=strtok(NULL,DELIMITER))){ /* NULL ̎́AWX^w薳 */
				if(ERROR==(i=r(pw)) || 3!=strlen(pw)){
					fprintf(stderr,"WX^̎w肪:");
					return (result->kind=ERROR);
				}
				if(i==0){
					fprintf(stderr,"wWWX^GR0͎gpłȂ:");
					return (result->kind=ERROR);
				}
				if(comma!=2){ /* J}͂Q̂͂ */
					fprintf(stderr,"Iyh̏:");
					return (result->kind=ERROR);
				}
				result->r2 = i;
			} else { /* NULL ̎́AWX^w薳 */
				if(comma!=1){ /* J}͂P̂͂ */
					fprintf(stderr,"Iyh̏:");
					return (result->kind=ERROR);
				}
			}
			break;
		}
	} else if(result->op == POP){
		if(ERROR==(i=r(result->oprand))){
			fprintf(stderr,"POPɎw肳ꂽWX^:");
			return (result->kind=ERROR);
		}
		result->r1=i;
	}
	free(p);
	result->op += (result->r1 << 4) + result->r2;
/* 󔒂̃XLbv */
	while(isspace(*s))
		s++;
/* ߂̏ */
	if(*s=='\n' || *s=='\0')
		return (NOERROR);
	strncpy(result->comment,s,LINESIZE);
	if(result->comment[LINESIZE-1]!='\0'){
		result->comment[LINESIZE-1]='\0';
		fprintf(stderr,"Rg:");
		return (ERROR);
	} else
		return (NOERROR);
}

CORD *opsearch(char *code){
	int top=0;
	int end=35;
	int mid;
	int flag;
	do{
		mid=(top+end)/2;
		if(0==(flag=strcmp(opcord[mid].op,code)))
			return(&opcord[mid]);
		else if(flag>0)
			end=mid-1;
		else		
			top=mid+1;
	}while(top<=end);
	return(NULL);
}

int r(char *gr){ /* WX^̔ԍԂ */
	int ret;

	if(*gr=='G' && *(gr+1)=='R' && *(gr+2)>='0' && *(gr+2)<='7')
		ret=*(gr+2)-'0';
	else
		ret=ERROR;
	return ret;
}

int countComma(char *str){
	int c=0;
	char *p=str;

	while(*p!='\0')
		if(','==*p++)
			c++;
	return (c);
}
