/* @Bꖽ */
#define NOP   0x0000
#define LD    0x1000
#define ST    0x1100
#define LAD   0x1200
#define LD1   0x1400
#define ADDA  0x2000
#define SUBA  0x2100
#define ADDL  0x2200
#define SUBL  0x2300
#define ADDA1 0x2400
#define SUBA1 0x2500
#define ADDL1 0x2600
#define SUBL1 0x2700
#define AND   0x3000
#define OR    0x3100
#define XOR   0x3200
#define AND1  0x3400
#define OR1   0x3500
#define XOR1  0x3600
#define CPA   0x4000
#define CPL   0x4100
#define CPA1  0x4400
#define CPL1  0x4500
#define SLA   0x5000
#define SRA   0x5100
#define SLL   0x5200
#define SRL   0x5300
#define JMI   0x6100
#define JNZ   0x6200
#define JZE   0x6300
#define JUMP  0x6400
#define JPL   0x6500
#define JOV   0x6600
#define PUSH  0x7000
#define POP   0x7100
#define CALL  0x8000
#define RET   0x8100
#define IN    0x9000
#define OUT   0x9100
#define RPUSH 0x9200
#define RPOP  0x9300
#define SVC   0xF000
#define START 0xE000
#define END   0xE001
#define DC    0xE010
#define DS    0xE011

/* WX^Ԗ߂̃oCAX */
#define RTOR  0x0400

/* s̑傫 i{́AK肳ĂȂ) */
#define LINESIZE 128
#define ERROR     -1
#define NOERROR    0
#define LABELSIZE  8
#define OPCODESIZE 5
#define OPRANDSIZE 16

/* ̎ */
#define COMMENT    0
#define ASSEMBLER  1
#define MACRO      2
#define MACHINE    4

/* Iyh̃f~^ */
#define DELIMITER ", \n"

/* TCY([h) */
#define MAXMEM    65536
#define UNDEFINED 65535

typedef unsigned short int WORD;

struct caslLine {
	char label[LABELSIZE + 1];   /* x̒́AőW + EOS */
	char opcode[OPCODESIZE + 1]; /* ߃R[h̒́AőT + EOS */
	char oprand[LINESIZE];       /* KFDC ̕萔ŝ */
	char address[LINESIZE];      /* AhX́Aȅꍇ */
	char comment[LINESIZE];      /* KFRg̃TCY͕ŝ */
	WORD op;                     /* R[hIyR[h */
	int  r1;                     /* P߂̃WX^ */
	int  r2;                     /* Q߂̃WX^ */
	int  size;                   /* ꒷ */
	int  kind;                   /* ߂̎ */
};

struct cord{
	char *op;
	WORD val;
	int size;
	int kind;
};

struct label {
	char *name;         /* x */
	WORD address;  /* x̎AhX */
	WORD top;      /* ̃xgp郁AhX̏ */
/*	WORD end;*/    /* ̃xgp郁AhX̏I gpȂ*/
	struct label *next; /* l[Xy[Xɑ鎟̃x */
	char *literal;      /* eIuWFNgicbIyh) */
};

struct namespace {
	char *name;             /* l[Xy[Xl[ */
	struct label *top;      /* ̃l[Xy[Xɑ郉x */
	struct namespace *next; /* ̃l[Xy[X */
};

typedef struct caslLine  SENTENCE;
typedef struct cord      CORD;
typedef struct label     LABEL;
typedef struct namespace NAMESPACE;

extern int   analyze(SENTENCE *result, char *line);
extern NAMESPACE *namespace_find(NAMESPACE *p, char *name);
extern LABEL *namespace_addLabel(char *spacename, char *labelname);
extern LABEL *namespace_findLabel(char *spacename, char *labelname);
extern void  namespace_drop(NAMESPACE *p);
extern char  *literalLabel(void);
extern WORD  strToNum(char *buff);
extern void  address(char *spacename, char *address);
extern int   pass1(char *filename);
extern void  memoryFileOut(FILE *fp, WORD start, WORD end);
extern void  command(void);

extern NAMESPACE *namespacetop;
extern WORD memory[MAXMEM];
extern WORD gr[8],sp,pr,fr;
extern WORD execute;  /* sJnԒn */

