#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <time.h>
#include "casl2.h"

/* FR 萔 */
#define OF 0x0100
#define SF 0x0010
#define ZF 0x0001

/* _ZƎZpZ */
#define LOGICAL      1
#define ARITHMETICAL 0

/* g[XXCb` */
#define OFF 0
#define ON  1

typedef int DWORD;       /* DWORD(32bit) > WORD */
typedef short int SWORD; /* signed WORD */

FILE *in, *out; /* hmCntsߗp̃t@Cڑ|C^ */
WORD execute=0; /* sJnԒn */
static unsigned long counter=0; /* SVC 254 ̃JE^ */

void run(int tr);
int decode(FILE *fp, WORD address);

void fr_set(WORD v) /* OF ̓NAII */
{
	fr=(v)? ((v & 0x8000)? SF :0 ): ZF ;
}
void fr_set2(DWORD v) /* CPߗp OF ̓NAII */
{
	fr=(v)? ((v < 0)? SF :0 ): ZF ;
}

void of_set(int x, int kind){
/* 	if(fr>=OF)fr-=OF; OF ̃NAAfr_setȂ̂łȂ */
	switch(kind){
	case LOGICAL:
		if(x < 0 || x > 65535) fr|=OF;
		break;
	case ARITHMETICAL:
	default:
		if(x < -32768 || x > 32767) fr|=OF;
		break;
	}
}

void command(void){
	int tr=OFF;  /* g[XXCb` */
	char cmd[64];/* R}h̓obt@ TCYɓɈӖ͂Ȃ 傫߂Ɋm */
	char filename[64];
	WORD  i,j;
	LABEL *lp;
	char label[LABELSIZE+1],namespace[LABELSIZE+1];

	pr=execute;
	in=stdin; out=stdout;
	printf("PR=#%04hX\n",pr);
	while(1){
		printf("OK>");
		gets(cmd);
		switch(cmd[0]){
		case 'H':/* HELP */
			printf("Help(this message):H\n"
				   "Dump:D startHexAddress endHexAddress\n"
				   "Trace ON or OFF:T(1|0)\n"
				   "Quit(CASL2 end):Q\n"
				   "Execute:E [executeHexAddress]\n"
				   "set to default execute address by label:=E namespace label\n"
				   "Continue:C\n"
				   "FileIn(set input file):FI filename\n"
				   "FileOut(set output file):FO filename\n"
				   "set value to register:=Rn hexValue\n"
				   "set value to memory by LABEL:=L namespace label hexValue\n"
				   "set value to memory by address:=#hexAddress hexValue\n"
				   "print rigitser value:?R(n|P|F)\n"
				   "print value of memory by label:?L namespace label\n"
				   "print value of memory by address:?#hexAddress\n"
				   "print immediate value:?Nnumber\n"
				   "print COUNTER as decimal notation:?C\n"
				   "print all registers:?\n");
			break;
		case 'D':/* DUMP */
			sscanf(cmd,"D %4hx %4hx", &i, &j);
			memoryFileOut(NULL, i, j);
			break;
		case 'T':/*TRACE ON or OFF: on is T1 ,off is T0 */
			tr=atoi(cmd+1);
			break;
		case 'Q':
			exit(EXIT_SUCCESS);
		case 'E':
			if(cmd[1]!='\0')
				sscanf(&cmd[1],"%4hx",&execute);
			pr=execute;
			sp=MAXMEM; /* sp=0: MAXMEM=65536 */
			counter=0L;
			run(tr);
			break;
		case 'C':
			run(tr);
			break;/* continue */
		case 'F':
			switch(cmd[1]){
				case 'I':
					sscanf(cmd,"FI %s",filename);
					if(NULL==(in=fopen(filename,"r"))){
						fprintf(stderr,"%sI[vł܂\n",filename);
						in=stdin;
					}
					break;
				case 'O':
					sscanf(cmd,"FO %s",filename);
					if(NULL==(out=fopen(filename,"w"))){
						fprintf(stderr,"%sI[vł܂\n",filename);
						out=stdout;
					}
					break;
				default :
					fprintf(stderr,"COMMAND ERROR\n");
					break;
			}
			break;
		case '=':
			switch(cmd[1]){
				case 'E':
					sscanf(cmd,"=E %s %s", namespace, label);
					if(NULL==(lp=namespace_findLabel(namespace, label))){
						fprintf(stderr,"xu%s:%sv͌Ȃ\n",namespace, label);
						continue;
					}
					pr=execute=lp->address;
					printf("PR=#%04hX\n",pr);
					break;
				case 'R':
					sscanf(cmd,"=R%hu %4hx",&i,&j);
					gr[i]=j;
					break;
				case 'L':
					sscanf(cmd,"=L %s %s %4hx", namespace, label, &i);
					if(NULL==(lp=namespace_findLabel(namespace, label))){
						fprintf(stderr,"xu%s:%sv͌Ȃ\n",namespace, label);
						continue;
					}
					memory[lp->address]=i;
					break;
				case '#':
					sscanf(cmd,"=#%4hx %4hx",&i,&j);
					memory[i]=j;
					break;
				default :
					fprintf(stderr,"COMMAND ERROR\n");
					break;
			}
			break;
		case '?': /* H̓vg̈ӁA */
			switch(cmd[1]){
			case 'R':
				if(isdigit(cmd[2])){
					i=atoi(&cmd[2]);
					printf("GR%hu=#%04hX\n", i, gr[i]);
				}
				else if('P'==cmd[2])
					printf("PC=#%04hX\n",pr);
				else if('F'==cmd[2])
					printf("FR=%03hu\n",fr);
				break;
			case 'L':
				sscanf(cmd,"?L %s %s", namespace, label, &i);
				if(NULL==(lp=namespace_findLabel(namespace, label))){
					fprintf(stderr,"xu%s:%sv͌Ȃ\n",namespace, label);
					continue;
				}
				printf("%s:%s[#%04hX]=#%04hX\n",namespace, label,lp->address, memory[lp->address]);
				break;
			case '#':
				sscanf(cmd,"?#%4hX",&i);
				printf("[#%04hX]=#%04hX\n", i, memory[i]);
				break;
			case 'N':
				i=strToNum(&cmd[2]);
				printf("%hd(S10) %hu(10) %04hX(16)\n",i,i,i);
				break;
			case 'C':
				printf("counter:%lu\n",counter);
				break;
			default :
				printf("GR0=#%04hX,GR1=#%04hX,GR2=#%04hX,GR3=#%04hX," ,gr[0],gr[1],gr[2],gr[3]);
				printf("GR4=#%04hX,GR5=#%04hX,GR6=#%04hX,GR7=#%04hX\n",gr[4],gr[5],gr[6],gr[7]);
				printf("PR=#%04hX,SP=#%04hX,fr[OSZ]=%03hX\n", pr, sp, fr);
			}
			break;
		default :
			fprintf(stderr,"COMMAND ERROR\n");
			break;
		}
	}
}
void run(int tr){
	int c;
	DWORD wk;
	WORD cord,r,adrx,xr,len;
	time_t now;

	if(tr==ON)printf("*TRACE MODE*\n");
	while(1){
		if(tr==ON){
			printf("GR0=#%04hX,GR1=#%04hX,GR2=#%04hX,GR3=#%04hX," ,gr[0],gr[1],gr[2],gr[3]);
			printf("GR4=#%04hX,GR5=#%04hX,GR6=#%04hX,GR7=#%04hX\n",gr[4],gr[5],gr[6],gr[7]);
			printf("PR=#%04hX,SP=#%04hX,fr[OSZ]=%03hX ", pr, sp, fr);
			decode(NULL, pr);
			while(1){
				printf("CorB>");
				c=getch();
				if(c=='B'){
					printf("\rBREAK\n");
					return;
				}
				else if(c=='C'){
					printf("\rCONTINUE\n");
					break;
				}
				else
					printf("\rCOMMAND ERROR\n");
			}
		}
		if(kbhit()){ /* [vĂ鎞̒Eoi WIł͂Ȃ*/
			c=getch();
			if(c=='B'){
				printf("BREAK\n");
				return;
			}
		}
		cord=memory[pr] & 0xFF00;
		r=memory[pr] & 0x00F0;
		xr=memory[pr] & 0x000F;
		adrx=memory[pr+1];
		if(xr)adrx+=gr[xr];/* AhX */
		r/=16;
		switch(cord){   /* ֐|C^ďo̕E */
			case LD  :
				fr_set(gr[r]=memory[adrx]);
				pr+=2;
				break;
			case LD1 :
				fr_set(gr[r]=gr[xr]);
				pr++;
				break;
			case ST  :
				memory[adrx]=gr[r];
				pr+=2;
				break;
			case LAD :
				fr_set(gr[r]=adrx);
				pr+=2;
				break;
			case ADDA :
				wk=(SWORD)gr[r]+(SWORD)memory[adrx];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, ARITHMETICAL);
				pr+=2;
				break;
			case ADDL :
				wk=gr[r]+memory[adrx];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, LOGICAL);
				pr+=2;
				break;
			case ADDA1:
				wk=(SWORD)gr[r]+(SWORD)gr[xr];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, ARITHMETICAL);
				pr++;
				break;
			case ADDL1:
				wk=gr[r]+gr[xr];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, LOGICAL);
				pr++;
				break;
			case SUBA :
				wk=(SWORD)gr[r]-(SWORD)memory[adrx];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, ARITHMETICAL);
				pr+=2;
				break;
			case SUBL :
				wk=gr[r]-memory[adrx];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, LOGICAL);
				pr+=2;
				break;
			case SUBA1:
				wk=(SWORD)gr[r]-(SWORD)gr[xr];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, ARITHMETICAL);
				pr++;
				break;
			case SUBL1:
				wk=gr[r]-gr[xr];
				fr_set(gr[r]=wk & 0xFFFF);
				of_set(wk, LOGICAL);
				pr++;
				break;
			case AND :
				fr_set(gr[r]&=memory[adrx]);
				pr+=2;
				break;
			case AND1:
				fr_set(gr[r]&=gr[xr]);
				pr++;
				break;
			case OR  :
				fr_set(gr[r]|=memory[adrx]);
				pr+=2;
				break;
			case OR1 :
				fr_set(gr[r]|=gr[xr]);
				pr++;
				break;
			case XOR :
				fr_set(gr[r]^=memory[adrx]);
				pr+=2;
				break;
			case XOR1:
				fr_set(gr[r]^=gr[xr]);
				pr++;
				break;
			case CPA :
				wk=(SWORD)gr[r]-(SWORD)memory[adrx];
				
				fr_set2(wk);
				pr+=2;
				break;
			case CPL :
				wk=gr[r]-memory[adrx];
				fr_set2(wk);
				pr+=2;
				break;
			case CPA1:
				wk=(SWORD)gr[r]-(SWORD)gr[xr];
				fr_set2(wk);
				pr++;
				break;
			case CPL1:
				wk=gr[r]-gr[xr];
				fr_set2(wk);
				pr++;
				break;
			case SLL :
				wk=gr[r] & 0x8000;
				fr_set(gr[r]<<=adrx);
				of_set(wk,ARITHMETICAL);/* 32768Zp͈̓eXgƃI[o[ */
				pr+=2;
				break;
			case SRL :
				wk=gr[r] & 0x0001;
				fr_set(gr[r]>>=adrx);
				of_set(-1*wk,LOGICAL);/* -1_͈̓eXgƃI[o[ */
				pr+=2;
				break;
			case SLA :
				fr_set(gr[r]);/* SFZbg */
				gr[r]<<=adrx;
				wk=(gr[r] & 0x8000)? -1:0; /* OF ۑ */
				if(fr & SF)
					gr[r]|=0x8000;
				else
					gr[r]&=0x7FFF;
				fr_set(gr[r]);
				of_set(wk,LOGICAL);
				pr+=2;
				break;
			case SRA :
				wk=gr[r] & 0x0001;
				fr_set((SWORD)gr[r]>>=adrx);
				of_set(-1*wk,LOGICAL);/* -1_͈̓eXgƃI[o[ */
				pr+=2;
				break;
			case JPL :
				pr=(0==(fr & (SF | ZF)))?adrx:pr+2;
				break;
			case JMI :
				pr=(fr & SF)?adrx:pr+2;
				break;
			case JNZ :
				pr=(0==(fr & ZF))?adrx:pr+2;
				break;
			case JZE :
				pr=(fr & ZF)?adrx:pr+2;
				break;
			case JOV :
				pr=(fr & OF)?adrx:pr+2;
				break;
			case JUMP:
				pr=adrx;
				break;
			case PUSH:
				memory[--sp]=adrx;
				pr+=2;
				break;
			case POP :
				gr[r]=memory[sp++];
				pr++;
				break;
			case CALL:
				memory[--sp]=pr+2;
				pr=adrx;
				break;
			case RET :
				if(sp==(WORD)MAXMEM){ /* OS փ^[ */
					fcloseall();
					in =stdin;
					out=stdout;
					return;
				} else 
					pr=memory[sp++];
				break;
			case IN  :
				if(in==stdin)printf("IN>");/* W͂̎vvgo */
				len=0;
				while(len<256){
					if(EOF==(c=fgetc(in))){
						len=-1;
						break;
					}
					if(c=='\n')
						break;
					memory[adrx + len++]=c;
				}
				memory[memory[pr+2]]=len;
				pr+=3;
				break;
			case OUT :
				len=memory[memory[pr+2]];
				while(len--)
					fputc(0xFF & memory[adrx++], out);
				fputc('\n', out);
				pr+=3;
				break;
			case RPUSH:
				for(c=1;c<8;c++)
					memory[--sp]=gr[c];
				pr++;
				break;
			case RPOP:
				for(c=1;c<8;c++)
					gr[c]=memory[sp++];
				pr++;
				break;
			case SVC :
				switch(adrx){
				case 100:/* ݎ̕\ */
					time(&now);
					fprintf(stdout,"%s\n",ctime(&now));
					pr+=2;
					break;
				case 254:/* COUNTER */
					counter++;
					pr+=2;
					break;
				case 255:/* BREAK */
					fprintf(stderr,"* system halt.\n");
					/* t@CĂ鎞AN[YAłȂ
					fcloseall();
					*/
					pr+=2;
					return;
				}
				break;
			case NOP :
				pr++;
				break;
			default  :
				printf("* system error.\n");
				return;
		}
		if(sp != 0 && sp < pr)
			printf("* SP WARNING.\n");
	}
}
char *codeTable[16][7] = {
	{ "NOP","","","","","","" },
	{ "LD","ST","LAD","","","","" },
	{ "ADDA","SUBA","ADDL","SUBL","","","" },
	{ "AND","OR","XOR","","","","" },
	{ "CPA","CPL","","","","","" },
	{ "SLA","SRA","SLL","SRL","","","" },
	{ "","JMI","JNZ","JZE","JUMP","JPL","JOV" },
	{ "PUSH","POP","","","","","" },
	{ "CALL","RET","","","","","" },
	{ "IN","OUT","RPUSH","RPOP","","","" },
	{ "","","","","","","" },
	{ "","","","","","","" },
	{ "","","","","","","" },
	{ "","","","","","","" },
	{ "","","","","","","" },
	{ "SVC","","","","","","" }
};
int decode(FILE *fp,WORD address){
/* fpaddress̓etAZuĕ\ */
/* ԒĺA߂̃TCY */
	WORD code,r,xr,adr1,adr2;
	WORD mainOp,subOp;
	int size;

	if(fp==NULL)fp=stdout;
	code=memory[address] & 0xFF00;
	mainOp = (code & 0xF000)>>12;
	subOp  = (code & 0x0F00)>>8;
	r=(memory[address] & 0x00F0)>>4;
	xr=memory[address] & 0x000F;
	adr1=memory[address+1]; /* f[^decodeŔz͈͊OɂȂ댯I */
	adr2=memory[address+2];

	switch(mainOp){
	case 0:
		fprintf(fp,"%5s\n", codeTable[mainOp][subOp]);
		size=1;
		break;
	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
		if(subOp<4){
			if(xr)
				fprintf(fp,"%5s GR%hu,#%04hX,GR%hu\n", codeTable[mainOp][subOp % 4], r, adr1,xr);
			else
				fprintf(fp,"%5s GR%hu,#%04hX\n", codeTable[mainOp][subOp % 4], r, adr1);
			size=2;
		} else {
			fprintf(fp,"%5s GR%hu,GR%hu\n", codeTable[mainOp][subOp % 4], r, xr);
			size=1;
		}
		break;
	case  6:
	case 15:
		if(xr)
			fprintf(fp,"%5s #%04hX,GR%hu\n", codeTable[mainOp][subOp], adr1, xr);
		else
			fprintf(fp,"%5s #%04hX\n", codeTable[mainOp][subOp], adr1);
		size=2;
		break;
	case 7:
		if(subOp){
			fprintf(fp,"%5s GR%hu\n", codeTable[mainOp][subOp], r);
			size=1;
		} else {
			if(xr)
				fprintf(fp,"%5s #%04hX,GR%hu\n", codeTable[mainOp][subOp], adr1, xr);
			else
				fprintf(fp,"%5s #%04hX\n", codeTable[mainOp][subOp], adr1);
			size=2;
		}
		break;
	case 8:
		if(subOp){
			fprintf(fp,"%5s\n", codeTable[mainOp][subOp]);
			size=1;
		} else {
			if(xr)
				fprintf(fp,"%5s #%04hX,GR%hu\n", codeTable[mainOp][subOp], adr1, xr);
			else
				fprintf(fp,"%5s #%04hX\n", codeTable[mainOp][subOp], adr1);
			size=2;
		}
		break;
	case 9:
		if(subOp<2){
			fprintf(fp,"%5s #%04hX,#%04hX\n", codeTable[mainOp][subOp], adr1, adr2);
			size=3;
		} else {
			fprintf(fp,"%5s\n", codeTable[mainOp][subOp]);
			size=1;
		}
		break;
	default:
		fprintf(fp,"UNKNOWN(#%04hX)\n", code);
		size=1;
		break;
	}
	return(size);
}
