#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "casl2.h"

NAMESPACE *namespacetop=NULL;

char *literalLabel(void){
/* ep̈ӂȃx쐬BۂɎgOɂ́ARs[Ȃ΂ȂȂ */
	static unsigned int no=0;
	static char buff[9];

	sprintf(buff,"l%07u",++no);
	return(buff);
}

LABEL *label_make(char *name){
	LABEL *p;

	if(NULL!=(p=(LABEL *)malloc(sizeof(LABEL)))){
		p->name=strdup(name);
		p->address=p->top=UNDEFINED;/* UTTRT͂蓾ȂlA܂薢`̈Ӗ */
		p->next=NULL;
		p->literal=NULL;
	}
	return(p);
}

void label_add(LABEL *p, LABEL *addp){
	if(p->next==NULL)
		p->next=addp;
	else
		label_add(p->next, addp);
}

LABEL *label_find(LABEL *p, char *name){
	if(p==NULL)return(NULL); /* [g̃x쐬ĂȂ */
	if(strcmp(p->name,name)) /* Ȃ */
		if(p->next==NULL)    /* ͂Ȃ */
			return(NULL);
		else
			return(label_find(p->next, name));
	else /*  */
		return(p);
}

/* sv
WORD *label_address(LABEL *p, char *name){
	LABEL *lp;

	if(NULL!=(lp=label_find(p, name)))
		return(lp->address);
	else
		return(UNDEFINED);
}
*/
void label_drop(LABEL *p){
	free(p->name);    /* strdupŊmۂĂ */
	free(p->literal); /* ɓANULL̎free͂ȂɂȂ */
	if(p->next!=NULL)
		label_drop(p->next);
	free(p);
}

NAMESPACE *namespace_make(char *name){
	NAMESPACE *p;

	if(NULL!=(p=(NAMESPACE *)malloc(sizeof(NAMESPACE)))){
		p->name=strdup(name);
		p->top=NULL;
		p->next=NULL;
	}
	return(p);
}

void namespace_add(NAMESPACE *p, NAMESPACE *addp){
	if(p->next==NULL)
		p->next=addp;
	else
		namespace_add(p->next, addp);
}

NAMESPACE *namespace_find(NAMESPACE *p, char *name){
	if(p==NULL)return(NULL); /* l[Xy[X쐬ĂȂ */
	if(strcmp(p->name,name)) /* Ȃ */
		if(p->next==NULL)    /* ͂Ȃ */
			return(NULL);
		else
			return(namespace_find(p->next, name));
	else /*  */
		return(p);
}

LABEL *namespace_addLabel(char *spacename, char *labelname){
	NAMESPACE *nsp;
	LABEL     *lp;

	nsp=namespace_find(namespacetop, spacename);
	if(nsp==NULL){ /* w肳ꂽl[Xy[XȂ */
		nsp=namespace_make(spacename);
		if(nsp==NULL){
			fprintf(stderr,"l[Xy[X(%s)쐬郁Ȃ",spacename);
			return(NULL);
		}
		if(namespacetop==NULL)
			namespacetop=nsp;
		else
			namespace_add(namespacetop, nsp);
	}
	lp=label_find(nsp->top, labelname);
	if(lp==NULL){ /* xȂ */
		lp=label_make(labelname);
		if(lp==NULL){
			fprintf(stderr,"x(%s)쐬郁Ȃ",labelname);
			return(NULL);
		}
		if(nsp->top==NULL)
			nsp->top=lp;
		else
			label_add(nsp->top, lp);
	} else {      /* ɂ鎞Axdo^悤ƂĂ */
		fprintf(stderr,"%s:%śAɓo^Ă",spacename,labelname);
	}
	return(lp);
}

LABEL *namespace_findLabel(char *spacename, char *labelname){
	NAMESPACE *nsp;
	LABEL     *lp;

	nsp=namespace_find(namespacetop, spacename);
	if(NULL==nsp)return(NULL); /* w肵l[Xy[XȂȂ */
	return(label_find(nsp->top, labelname));
}

void namespace_drop(NAMESPACE *p){
	free(p->name);    /* strdupŊmۂĂ */
	if(p->top!=NULL)
		label_drop(p->top);      /* ێĂ郉x̂Ă */
	if(p->next!=NULL)
		namespace_drop(p->next); /* AȂl[Xy[X̂ĂĂ */
	free(p);                     /* ̂Ă */
}
