#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <assert.h>
#include "casl2.h"

/* X^[g߂n܂Ă邩\ */
#define STARTED 1
#define ENDED   0

char namespace[LABELSIZE +1]; /* ݂̃vO̓ێ */

FILE *casfopen(const char *fname)
/* CAS(CASL2) FILE OPEN */
{
	FILE *fr;
	char *s, *buff;

	if(NULL==(buff=malloc(strlen(fname)+5))){ /* 5 is .CAS\0 */
		fprintf(stderr,"Ɨp̃܂B\n");
		fr=NULL;
	} else {
		strcpy(buff,fname);
		if(NULL!=(s=strrchr(buff,'.'))){ /* 납'.'T */
			strupr(buff);
			if(strcmp(s+1,"CAS")){
				fprintf(stderr,"t@C̊gqCASł͂܂\n");
				fr=NULL;
			} else
				fr=fopen(fname,"r");
		} else { /* '.'t@CɂȂ */
			fr=fopen(strcat(buff,".CAS"),"r");
		}
		free(buff);
	}
	return(fr);
}

int pass1(char *filename){
	char start[LABELSIZE + 1]; /* [sJnԒn]x̕ێ */
	char buff[LINESIZE];
	FILE *fp;
	SENTENCE result;
	int lineno=0;
	int err=0,started,strFlag;
	NAMESPACE *np;
	LABEL *lp;
	char *s,*p;
	WORD wk,next;

	if(NULL==(fp=casfopen(filename))){
		fprintf(stderr,"%s can not open!\n",filename);
		exit(EXIT_FAILURE);
	}

	started = ENDED; /* START ߂n܂ĂȂ */
	*start='\0';
	while(NULL!=fgets(buff, LINESIZE, fp)){
		/* sobt@̃TCY𒴂Ăꍇ̌oȂ */
		/* isԍȂǏ󂪂ł邵jG[ɂȂ̂ł킩 */
		lineno++;
		if(ERROR==analyze(&result, buff)){
			fprintf(stderr,"at %d in %s\n",lineno,filename);
			err++;/* G[̐𐔂 */
			continue;
		}
		assert(ERROR!=result.kind);/* ERRORł͂肦Ȃ͂łB */
		if(result.kind==COMMENT || result.kind==ERROR) continue;
		if(result.op==START){
			if(started != ENDED){
				fprintf(stderr,"END߂ŃvOIĂȂ̂START߂ at %d in %s\n",lineno,filename);
				exit(EXIT_FAILURE); /* G[炾ł̂ŁAIĂ܂ */
			}
			if(result.label[0]=='\0'){
				fprintf(stderr,"START߂ɂ́AxKv at %d in %s\n",lineno,filename);
				exit(EXIT_FAILURE); /* G[炾ł̂ŁAIĂ܂ */
			}
			strcpy(namespace, result.label); /* ́Al[Xy[XƂĎg */
			if(NULL!=(lp=namespace_findLabel(namespace, result.label))){
				fprintf(stderr,"łɃxo^Ă at %d in %s\n",lineno,filename);
				err++;
				continue;
			}
			if(NULL==(lp=namespace_addLabel(namespace, result.label))) /* vIG[iȂj */
				exit(EXIT_FAILURE);
			if(NULL!=(lp=namespace_findLabel("global", result.label))){ /* START̃x́AL於ƂĂo^ */
				fprintf(stderr,"łɃxo^Ă at %d in %s\n",lineno,filename);
				err++;
				continue;
			}
			if(NULL==(lp=namespace_addLabel("global", result.label))) /* vIG[iȂj */
				exit(EXIT_FAILURE);
			if(result.oprand[0]!='\0'){ /* [sJnԒn]w肪 */
				if(strlen(result.oprand)>LABELSIZE){
					fprintf(stderr,"START߂[sJnԒn]w肪 at %d in %s\n",lineno,filename);
					err++;
					continue;
				}
				strcpy(start ,result.oprand);/* sJnԒñx́A̎_ł͌肵ĂȂ */
			} else {
				*start='\0';
				lp=namespace_findLabel(namespace, result.label);
				lp->address=pr; /* sJnԒn̎w肪ȂAvO̐擪 */
				lp=namespace_findLabel("global", result.label);
				execute=lp->address=pr; /* vOŜ̎sJnԒn͍Ō̃vO̎sJnԒnftHg */
			}
			started = STARTED;
			continue;
		} else if(started != STARTED){ /* START߂łȂ̂ɁA܂vOX^[gĂȂ */
			fprintf(stderr,"START߂ŃvOJnĂȂ at %d in %s\n",lineno,filename);
			exit(EXIT_FAILURE); /* G[炾ł̂ŁAIĂ܂ */
		}
		if(result.oprand[0]!='\0' && (result.op == RET || result.op == NOP || result.op == RPUSH || result.op == RPOP || result.op == END)){
			fprintf(stderr,"Iyh͎włȂ at %d in %s\n",lineno,filename);
				err++;
				continue;
		}
		if(result.label[0]!='\0'){ /* x鎞o^Ałx̓AhXς݂̂ */
			assert(NULL!=namespace); /* ̎ɂ́A`Ă͂ */
			if(result.op == END){
				fprintf(stderr,"END߂Ƀx͕tȂ at %d in %s\n",lineno,filename);
				err++;
				continue;
			}
			if(NULL!=(lp=namespace_findLabel(namespace, result.label))){ /* x */
				if(lp->address!=UNDEFINED){  /* ɒ`ς */
					fprintf(stderr,"łɃxo^Ă at %d in %s\n",lineno,filename);
					err++;
					continue;
				}
			} else if(NULL==(lp=namespace_addLabel(namespace, result.label))) /* Vo^ */
				exit(EXIT_FAILURE); /* vIG[iȂj */
			lp->address=pr;
		}
		if(result.size==1){ /* ꒷P̂ */
			memory[pr++]=result.op;
			continue;
		}
		switch(result.op){
/*
		  case START:break; //ς
		  case NOP:
		  case RET:
		  case RPUSH:
		  case RPOP:break; //ς
*/
		  case END:
			started = ENDED;
			/* ȅo */
			if(NULL!=(np=namespace_find(namespacetop, namespace))){ /* START߂ɂăl[Xy[X`Ă΁Al[Xy[XxȂ炸 */
				for(lp=np->top;lp!=NULL;lp=lp->next){
					if(lp->name[0]=='l'){ /* ẽx͏̃GŎn܂ */
						lp->address=pr;
						address(namespace,lp->literal);
					}
				}
				/* START߂̎sJnԒnw̏ */
				if(*start!='\0'){
					lp=namespace_findLabel(namespace, start);/* ̎_ł͕K茈肵Ă͂ */
					if(lp==NULL){
						fprintf(stderr,"START߂Ŏw肳ꂽsJnԒñvOŒ`ĂȂ\n");
						exit(EXIT_FAILURE);
					}
					if(lp->address==UNDEFINED){
						fprintf(stderr,"START߂Ŏw肳ꂽsJnԒñvOŒ`ĂȂ\n");
						exit(EXIT_FAILURE);
					}
					execute=lp->address;
					lp=namespace_findLabel(namespace, namespace); /* ̃AhX̌ */
					lp->address=execute;
					lp=namespace_findLabel("global", namespace); /* iL於)̃AhX̌ */
					lp->address=execute;
				}
				/* x̏ */
				for(lp=np->top;lp!=NULL;lp=lp->next){
					if(lp->address!=UNDEFINED){ /* AhXɌ肵ĂA*/
						if(lp->top!=UNDEFINED){ /* xQƃXgĂ */
							for(wk=lp->top;;wk=next){
								next=memory[wk];       /* ̏ꏊҔĂ */
								memory[wk]=lp->address;/* x̃AhX̖ߍ */
								if(next==lp->top){
									lp->top=UNDEFINED; /* QƃXgȂɂĂ */
									break; /* Xg̏I */
								}
							}
						}
					} /* END߂̂ƂŖx͓iL於j */
					  /* L於̉́APASS IIiSẴvOǂݍ񂾎jɁA */
				}
			}
			break;
		  case DS:
			if(result.oprand=='\0'){
				fprintf(stderr,"DS߂ɂ͌ꐔKv at %d in %s\n",lineno,filename);
				err++;
				continue;
			}
			pr += strToNum(result.oprand); /* {́Al`FbNKv */
			break;
		  case DC:
		  /* oprand́u,v̌JԂŁAaddressɐ؂o */
			s=result.oprand;
			p=result.address;
			*p='\0';
			strFlag=0; /* 萔̎͂P */
			for(;;){
				if((*s==',' && strFlag==0) || *s=='\0'){ /* ؂oI */
					*p='\0';
					address(namespace, result.address);
					if(*s==','){
						p=result.address;
						*p='\0';
						s++;
						continue;
					} else
						break;
				} else if (*s=='\''){
					if(strFlag){
						if(*(s+1)=='\''){ /* 萔''̎ */
							*p++=*s++;
						} else
							strFlag=0; /* 萔I*/
					} else
						strFlag=1; /* 萔n܂ */
				}
				*p++=*s++;
			}
			break;
		  case IN:
		  case OUT:
			memory[pr++]=result.op;
		  /* oprand́u,v̌JԂŁAaddressɐ؂o */
			s=result.oprand;
			p=result.address;
			*p='\0';
			for(;;){
				if(*s==',' || *s=='\0'){ /* ؂oI */
					*p='\0';
					address(namespace, result.address);/* xłȂeĝ͊gdl */
					if(*s==','){
						p=result.address;
						*p='\0';
						s++;
						continue;
					} else
						break;
				}
				*p++=*s++;
			}
			break;
		  default: /* Q꒷̋@Bꖽ */
			memory[pr++]=result.op;
			address(namespace, result.address);
			break;        
		}
	}
	if(feof(fp) && started != ENDED){
		fprintf(stderr,"vOEND߂ŏIĂȂ\n");
		exit(EXIT_FAILURE);
	}
	fclose(fp);
	return(err); /* G[̐OȂNOERROR */
}
void address(char *spacename, char *address){
/* POi萔iO`UTTRUj
   PUi萔iwwwwj
   萔ifstringsfj
   AhX萔ixj
   eiPOi萔bPUi萔b萔jłcb߂쐬ÃAhXlƂ */
/* ̊֐́AAhX萔⃊ȅ̎̃ɐς */
	WORD wk;
	char *p;
	LABEL *lp;

	switch(*address){
	  case '=': /* e */
		p=literalLabel();
		lp=namespace_addLabel(spacename, p);
		lp->literal=strdup(address+1);/* =ĕۑĂ */
		lp->top=pr;
		memory[pr++]=lp->top; /* xƓ */
		break;
	  case '\'':/* 萔 */
		for(p=address+1;*p!='\0';p++){
			if(*p=='\''){
				if(*(p+1)=='\''){
					p++;
				} else if(*(p+1)=='\0')
					break;
				else
					fprintf(stderr,"萔̏\n");/* ̎_ł͋N肦Ȃ */
			}
			memory[pr++]=0x00FF & *p;
		}
		break;
	  case '#': /* l萔 */
	  case '-':
	  case '0':
	  case '1':
	  case '2':
	  case '3':
	  case '4':
	  case '5':
	  case '6':
	  case '7':
	  case '8':
	  case '9':
		memory[pr++]=strToNum(address);
		break;
	  default: /* x */
		if(NULL!=(lp=namespace_findLabel(spacename, address))){ /* Ƀxo^Ă */
			if(lp->address!=UNDEFINED){ /* ɃAhX肵ĂBix萔UTTRUɂȂ邱Ƃ͂蓾Ȃj */
				memory[pr++]=lp->address;
			} else {
				if(lp->top==UNDEFINED){ /* ܂Axo^ĂȂA菇ɏ]Ă΂肦Ȃ */
					memory[pr]=lp->top=pr; /* ̃ƃgbvɂɍ̃AhX */
					pr++;
				} else {
					for(wk=lp->top;memory[wk]!=lp->top;wk=memory[wk]);/* gbvwĂ郁T */
					memory[wk]=pr;    /* ̃Ȃ */
					memory[pr++]=lp->top;/* Ōɖڈt */
				}
			}
		} else {
			if(NULL!=(lp=namespace_addLabel(spacename, address))){
				memory[pr]=lp->top=pr; /* ̃ƃgbvɂɍ̃AhX */
				pr++;
			}
		}
		break;
	}
}
void memoryFileOut(FILE *fp, WORD start, WORD end){
	WORD c,wk;

	if(fp==NULL)fp=stdout;
	for(c=start;c<end;){
		switch(memory[c] & 0xFF00){
		  case LD: /* Q꒷ */
		  case ST:
		  case LAD:
		  case ADDA:
		  case SUBA:
		  case ADDL:
		  case SUBL:
		  case AND:
		  case OR:
		  case XOR:
		  case CPA:
		  case CPL:
		  case SLA:
		  case SRA:
		  case SLL:
		  case SRL:
		  case JMI:
		  case JNZ:
		  case JZE:
		  case JUMP:
		  case JPL:
		  case JOV:
		  case PUSH:
		  case CALL:
		  case SVC:
			fprintf(fp,"%04hX:%04hX %04hX\n",c,memory[c],memory[c+1]);
			c+=2;
			break;
		  case IN: /* R꒷ */
		  case OUT:
			fprintf(fp,"%04hX:%04hX %04hX %04hX\n",c,memory[c],memory[c+1],memory[c+2]);
			c+=3;
			break;
		  default:
			fprintf(fp,"%04hX:%04hX\n",c,memory[c]);
			c++;
			break;
		}
	}
}
